var loading = true;		//是否在加载中
var pageAll = 0;		//总页数
var pageNow = 0;		//当前页码
var pcp = 0;		//当前页的回复条数
var end = false;		//是否数据加载完成
var recommend = 1;		//是否已经点赞  0——已赞    1——未赞
var login = false;		//是否登录
var tid;				//帖子id
var uid;				//当前用户id

//app回调函数(wap也会用)
var appCallback = {
	//打开页面时首次加载页面内容的回调
	readInfo: function (res) {
		if (res) {
			var data = JSON.parse(JSON.stringify(res));
		}
		if (data.Message){
			$('#noReply').text(data.Message.messagestr);
		}
		if (data.Variables.postlist.length==0){
			return;
		}
		pageAll = Math.ceil((+data.Variables.thread.replies + 1) / data.Variables.ppp);
		pcp = data.Variables.postlist.length;
		tid = data.Variables.thread.tid;
		uid = data.Variables.member_uid;
		pageNow++;
		
		//从列表中拿出楼主的信息
		var first = data.Variables.postlist.shift();
		$('title').html(data.Variables.thread.subject);
		//生成楼主的数据对象
		var floor = {
			author: first.author,
			authorid: first.authorid,
			dateline: first.dateline,
			subject: data.Variables.thread.subject,
			message: first.message,
			avatars: data.Variables.avatars2
		}
		//帖子可否点赞
		recommend = Number(data.Variables.is_recommend_duplicate);
		
		//判断是否登录,以后可能有更好的方法
		login = (data.Variables.member_uid != "0" && data.Variables.member_username) ? true : false;
		if(!recommend){
			$(".post-data-praise").addClass("none");
			//登录用户添加点赞功能
			if (login) {
				$('.none').click(function(e){
					$(this).removeClass('none').text(Number($(this).text()) + 1).off('click');
					$.dxlBbsCallBack('recommend', null, {
						action: "recommend",
						do: "add",
						tid: tid
					})
				});
			} else {
				$('.none').click(function(e){
					$.dxlBbsCallBack('recommend', null, {
						action: "recommend",
						do: "add",
						tid: tid
					})
				});
			}
		}
		
		
		post(floor, imageList(first));
		refresh(data);
		judge();
		//当帖子没有回复时的处理
		if (data.Variables.postlist.length == 0){
			$('#noReply').text('暂无评论');
			$('#noReply').addClass('noReply');
		} else{
			data.Variables.postlist.forEach(function(comlist){
				$('.comment-list').append(comment(comlist, data.Variables.avatars2));
			});
		}

		//页面加载完成；
		imgEvent();
		setTimeout(function(){
			$('.bbs-header,.title-wrap,.post-sec,.comment-list').css('opacity', 1);
			$(".post-data-praise").addClass("loadok");
		},0);
	},
	
	
	//回复贴子的回调（app中快速回复也会调用）
	replyCb: function (info) {
		if(info){
			var data = JSON.parse(JSON.stringify(info));
		};
		login = (data.Variables.member_uid != "0" && data.Variables.member_username) ? true : false;
		pageAll = Math.ceil((+data.Variables.thread.replies + 1) / data.Variables.ppp);
		
		var postlist = data.Variables.postlist;
		
		
		//获取当前页的内容，将已加载的内容过滤掉；
		if(postlist.length > pcp){
			
			var newPostlist = postlist.slice(pcp);
			pcp = postlist.length;

			newPostlist.forEach(function(comlist){
				$('.comment-list').append(comment(comlist, data.Variables.avatars2));
			});
			$('#noReply').removeClass('noReply');
			//新加载的图片绑定事件
			imgEvent();
		};
		refresh(data);
		judge();
	},
	
	
	//加载下一页内容；
	pagination: function (info) {
		if (info) {
			var data = JSON.parse(JSON.stringify(info));
		};
		++pageNow;
		login = (data.Variables.member_uid != "0" && data.Variables.member_username) ? true : false;
		data.Variables.postlist.forEach(function(comlist){
			$('.comment-list').append(comment(comlist, data.Variables.avatars2));
		});
		pageAll = Math.ceil((+data.Variables.thread.replies+1) / data.Variables.ppp);
		pcp = data.Variables.postlist.length;
		
		//新加载的图片绑定事件
		imgEvent();
		refresh(data);
		judge();
	}
}

//判断是否加载完毕
function judge(){
	if(pageAll == pageNow){
		$('#noReply').text('- end -');
		end = true;
	}else{
		$('#noReply').text('加载中……');
		end = false;
	}
	loading = false;
}

//点击图片事件的响应函数
function imgClick(event){
	if(event.target.tagName=='IMG'&&(event.target.width>50)){
		event.preventDefault();
		var imgUrls = [];
		var index = 0;
		var count = 0;
		$(this).find('img').each(function(i, ele){
			if(event.target == ele){
				index = count;
			};
			if (ele.width>50) {
				imgUrls.push(ele.getAttribute('src'));
				count++;
			};
		});
		
		$.dxlBbsCallBack('bigImg',null,{
			index: index,
			imgUrls: imgUrls
		});
	}
}

//给新加入楼层dom元素绑定图片点击事件
function imgEvent(){
	$('.new img').css('height','auto');
	
	//只有app才需要绑定点击事件
	if($.platform == "appIos" || $.platform == "appAndroid"){
		$('.new').each(function(i, ele){	//为新加载的评论中有图片的dom元素绑定点击图片事件

			if($(ele).find('img').length>0){
				$(ele).click(imgClick);
			}
		});
	}
	
	$('.new').removeClass('new');
}

//每次加载数据时更新帖子浏览量、回复数、点赞数
function refresh(data) {
	$('.post-data-views').text(data.Variables.thread.views);
	$('.post-data-allreplies').text(data.Variables.thread.allreplies);
	$('.post-data-praise').text(data.Variables.thread.recommend_add);
}


//楼主数据填充
function post(data, imgs){
	//为表情设定图片大小
	var msg = data.message.replace(/src=\"http:\/\/bbs.daoxila.com\/static\/image\/smiley/g, 'width="24" src="' + dxlHttp.bbs + 'static/image/smiley');
	if($('.bbs-time').length>0){
		$('.bbs-time').html(data.dateline);
	}
	$('.title').html(data.subject);
	$('.avatar-wrap .avatar').attr('src', data.avatars[data.author] ? data.avatars[data.author] : dxlHttp.s4 + 'm-bbs/img/post/avatar.png')
	$('.floor-host .user-name').text(data.author);
	$('.floor-host .user-time').html(data.dateline);
	$('.post-main').html(msg);
	$('.img').append(imgs);
};

//评论数据填充
function comment(data, avatars){
	//为表情设定图片大小
	var msg = data.message.replace(/src=\"http:\/\/bbs.daoxila.com\/static\/image\/smiley/g, 'width="24" src="'+ dxlHttp.bbs +'static/image/smiley');
	var html = '<div class="comment clearfix" data-pid="'+ data.pid +'">' +
					'<div class="comment-avatar-wrap">' +
						'<img src="' + (avatars[data.author] ? avatars[data.author] : dxlHttp.s4 + 'm-bbs/img/post/avatar.png') + '" class="avatar">' + 
					'</div>' +
					'<div class="comment-user-wrap clearfix">' +
						'<h4 class="user-name">' + data.author + '</h4>' +
						'<p class="user-info">' + 
							'<span class="user-status">' + (data.position - 1) + '楼</span> | <span class="user-time">' + data.dateline +'</span>' +
						'</p>' +
						'<i class="reply" data-position="' + data.position + '" data-username="'+ data.username +'" data-dbdateline="'+ data.dbdateline + '"></i>' +
					'</div>' +
					'<div class="comment-content new">' +
						'<div class="comment-main">' + msg + '</div>' +
						'<div class="img">' + imageList(data) + '</div>' +
					'</div>' +
					'<div class="comment-praise loadok ' + (data.is_support=='1' ? '' : 'none') + '">' + (data.postreview ? data.postreview.support : '0') + '</div>' +
				'</div>';
	return html;
};

//拼装图片
function imageList(data){
	var imgsurl = [];
	//拼装回复的图片
	if(data.imagelist&&data.attachments){
		data.imagelist.forEach(function(ele,index){
			imgsurl.push(data.attachments[ele].url + data.attachments[ele].attachment);
		});
	}
	var str = '';
	imgsurl.forEach(function(ele, index){
		str += '<img src="'+ ele + '"/>';
	})
	return str;
}


//文件加载完成

$(document).ready(function(){
	
	$('.post-content').addClass('new');//添加new为了给楼主发的图片添加点击事件；
	$('body').append('<div id="noReply">加载中……</div>');
	
	$.mTopCall();
	
	
	if($.platform == "appIos" || $.platform == "appAndroid"){
		
	//app端
		$('html').addClass("app");
		//加载页面数据
		$.dxlBbsCallBack('postInfo','appCallback.readInfo');
		
		//代理评论列表的所有点击事件
		$('.comment-list').click(function(e){
			var $this = $(e.target);
			
			if($this.hasClass("reply")){
				
				//回复事件
				var msg = '';
				if ($this.parents('.comment').find('.reply_wrap')){
					msg = $this.parents('.comment').find('.comment-main').text().slice($this.parents('.comment').find('.reply_wrap').text().length).replace(/(^\s*)|(\s*$)/g, "");
				}else{
					msg = $this.parents('.comment').find('.comment-main').text();
				}
				if($this.parents('.comment').find('.comment-content img').length > 0){
					var i = $this.parents('.comment').find('.comment-content img').length;
					for(;i-->0;){
						msg += '[引用图片]';
					}
				}

				$.dxlBbsCallBack('reply','replyCb',{
					username: $this.data('username')+'',
					dbdateline: $this.data('dbdateline')+'',
					message: msg+'',
					pid: $this.parents('.comment').data('pid')+'',
					floor: $this.data('position')-1+''
				});
				
			} else if ($this.hasClass("comment-praise") && $this.hasClass("none")) {
				
				//点赞事件
				if(login){
					$this.removeClass('none').text(Number($this.text()) + 1);
					$.dxlBbsCallBack('postreview', null, {
						action: "postreview",
						do: "support",
						tid: tid,
						pid: $this.parents('.comment').data('pid')+''
					})
				} else {
					$.dxlBbsCallBack('postreview', null, {
						action: "postreview",
						do: "support",
						tid: tid,
						pid: $this.parents('.comment').data('pid')+''
					})
				}
			}
		});
		
		//加载页面
		$(window).scroll(function(){
			if($(window).scrollTop()+50 >= $(document).height() - $(window).height() && !end && !loading){
				loading = true;
				$.dxlBbsCallBack('pagination', 'appCallback.pagination', {page:pageNow + 1});
			}
		});
		
	} else {
		
	//wap端
		$('html').addClass("wap");
		
		var tid = $.isUrlPar('tid');
		
		$.viewthread({
			tid: tid,
			page: pageNow + 1
		}, appCallback.readInfo);
		
		
		//加载页面
		$(window).scroll(function(){
			if($(window).scrollTop()+50 >= $(document).height() - $(window).height() && !end && !loading){
				loading = true;
				$.viewthread({
					tid: tid,
					page: pageNow + 1
				}, appCallback.pagination);
			}
		});
		
		//添加app下载banner条
		$('#appDownBot .close').touchClick(function(e){
			e.stopPropagation();
			e.preventDefault();
			$('#appDownBot').hide();
			$('body').css({"padding-bottom":"0"});
			$('#backTop').css({"bottom":"30px"});
		});
		$('#appDownBot').touchClick(function(e){
			window.location.href = dxlHttp.m + "app?utm_source=App&utm_content=ziyou&utm_term=BBS";
		})
		
	}
});
