//app方法：
//参数为：1，调用app原生方法名。2，回调函数名。3，传参数组。
//传参数组的数组元素为只有一个属性名值对的对象。
dxlHttp.bbs = windowHttp + '//bbs.daoxila.' + s4Com + "/";
;(function ($) {
	$.extend({
		bbsApi: 'api/mobile/index.php?'
	});
	if (navigator.userAgent.indexOf("dxlapp-android") != "-1"){
		$.extend({
			'platform': "appAndroid",
			'dxlBbsCallBack': function (action, cb, par) {
				if (!cb){
					cb = 'null';
				};
				if(!par){
					par = {};
				}
				window.android.forumCallBack(action, cb, JSON.stringify(par));

			}
		});
	}else if(navigator.userAgent.indexOf("dxlapp-iphone") != "-1"){
		$.extend({
			'platform': "appIos",
			'dxlBbsCallBack': function (action, cb, par) {

				var option = {};
				option.title = action;
				if (cb && cb!=='null'){
					option.callback = cb;
				};
				if(par){
					for(var key in par){
						option[key] = par[key];
					};
				}
				
				var uri = 'gap://XXX#' + JSON.stringify(option);
				window.location = uri;
			}
		});
	} else {
		$.extend({
			'platform': "normal",
			'viewthread': function (par, callback, context) {		//获取指定页面的数据
				var def = {
					module: "viewthread",
					version: 4,
					ppp: 15
				}
				if (!context) {
					context = window;
				}
				def = $.extend(def, par);
				$.get(dxlHttp.bbs + $.bbsApi + $.param(def), function(data){
					callback.call(context, data);
				});
			}
		});
	}
})(jQuery);